#[derive(
    Debug,
    Clone,
    conjure_object::serde::Serialize,
    conjure_object::serde::Deserialize,
    PartialEq,
    Eq,
    PartialOrd,
    Ord,
    Hash
)]
#[serde(crate = "conjure_object::serde")]
#[conjure_object::private::staged_builder::staged_builder]
#[builder(crate = conjure_object::private::staged_builder, update, inline)]
pub struct CheckAlertStatesFilter {
    #[builder(
        custom(
            type = super::super::super::rids::api::CheckAlertState,
            convert = Box::new
        )
    )]
    #[serde(rename = "checkAlertState")]
    check_alert_state: Box<super::super::super::rids::api::CheckAlertState>,
    #[serde(rename = "operator")]
    operator: super::super::super::internal::search::api::Operator,
    #[serde(rename = "threshold")]
    threshold: conjure_object::SafeLong,
}
impl CheckAlertStatesFilter {
    /// Constructs a new instance of the type.
    #[inline]
    pub fn new(
        check_alert_state: super::super::super::rids::api::CheckAlertState,
        operator: super::super::super::internal::search::api::Operator,
        threshold: conjure_object::SafeLong,
    ) -> Self {
        Self::builder()
            .check_alert_state(check_alert_state)
            .operator(operator)
            .threshold(threshold)
            .build()
    }
    #[inline]
    pub fn check_alert_state(&self) -> &super::super::super::rids::api::CheckAlertState {
        &*self.check_alert_state
    }
    #[inline]
    pub fn operator(&self) -> &super::super::super::internal::search::api::Operator {
        &self.operator
    }
    #[inline]
    pub fn threshold(&self) -> conjure_object::SafeLong {
        self.threshold
    }
}
